/*
 *  exo02.h
 *  operations sur les polynomes
 */
#define MAX 1000
#include <stdio.h>

void lirePol(int res[], unsigned int *degres) {
  printf("Svp, tapez le degré du polynom : ");
  scanf("%d",degres); // degres est déjà un pointeur
  while(*degres > MAX){//pour s'assurer que *degres n'est pas trop elevé
    printf("Erreur, le degré est trop elevé (MAX = %d)\n",MAX);
    printf("Svp, retapez le degré du polynom : ");
    scanf("%d",degres);
  }
  unsigned int i;
  for(i = 0; i <= *degres; i++) { // on cycle jusqu'à *degres inclus
    printf("Svp, tapez le %de coefficient : ",i);
    scanf("%d",&res[i]);
  }
  while(res[*degres] == 0 && *degres > 0) (*degres)--;
}

void affichePolRenv(int pol[], unsigned int deg) {
  if(deg == 0) {
    printf("%d",pol[0]);           // si le polynome est constant
    return;
  }
  unsigned int i = 0;
  while (pol[i] == 0) i++;
  if(i == 0) printf("%d",pol[0]);
  else {
    if (pol[i] == 1) printf("X");
    else if (pol[i] == -1) printf("-X");
    else printf("%dX",pol[i]);
    if (i > 1) printf ("^%d",i);
  }
  while(i<=deg) {
    i++;
    if (pol[i] == 0) continue; // les coefficients nuls sont sautès
                               // pas de besoin de contrôler si on
                               // doit sortirs, car pol[deg] != 0
    if (pol[i] > 0) printf(" +"); // on affiche + si positif
    else printf(" "); // le "-" sera affiché par le nombre
    if (pol[i] == 1) {
      printf("X");
    } else if (pol[i] == -1) {
      printf("-X");
    } else {
      printf("%dX",pol[i]);
    }
    // si le coefficient est 1 ou -1 on n'affiche pas 1
    if (i > 1) printf("^%d",i);
    // on affiche l'exponant si c'est different de 1
  }
}

void affichePol(int pol[], unsigned int deg) {
  if(deg == 0) {
    printf("%d",pol[0]);           // si le polynome est constant
    return;
  }
  unsigned int i = deg; // pol[deg] est non nul, et deg > 0
  if(pol[i] == 1) printf("X");
  else if (pol[i] == -1) printf("-X");
  else printf("%dX",pol[deg]);
  if (i > 1) printf ("^%d",i);
  while(1) {
    i--;
    if (pol[i] == 0) {
      if (i == 0) break; // sortie du cycle
      else continue; // les coefficients nuls sont sautès
    }
    if (pol[i] > 0) printf(" +"); // on affiche + si positif
    else printf(" "); // le "-" sera affiché par le nombre
    if (i == 0) {
      printf("%d",pol[0]);
      break; // sortie du cycle
    }
    if (pol[i] == 1) {
      printf("X");
    } else if (pol[i] == -1) {
      printf("-X");
    } else {
      printf("%dX",pol[i]);
    }
    // si le coefficient est 1 ou -1 on n'affiche pas 1
    if (i > 1) printf("^%d",i);
    // on affiche l'exponant si c'est different de 1
  }
}

void multPol(int res[], unsigned int *degres, int a[],
                                              unsigned int dega,
                                              int b[],
                                              unsigned int degb) {
  unsigned int i;
  unsigned int j;
  int resultat[MAX];  // on utilise un copie local du resultat
                      // pour pouvoir calculer pour ex
                      // multPol(a,dega,a,*dega,b,degb)
                      // (l'equivalant de a *= b)
  unsigned int deg = dega + degb;
  if(deg > MAX) deg = MAX;
  for(i = 0; i <= deg; i++) {
    resultat[i] = 0; // initialisation
    if (i > degb) j = i-degb;
    else j = 0; // initialisation conditionelle de j
                // (donc dehors le for)
                // cela evite que i-j soit plus élevé que degb
    for(; (j <= i) && (j <= dega); j++) {
      resultat[i] += a[j]*b[i-j];
    }
  }
  // maintenant c'est sûr de copier resultat sur res
  for(i = 0; i <= deg; i++) res[i] = resultat[i];
  *degres = deg;
}

void puissPol(int res[], int *degres, int b[], int degb, unsigned int e) {
  int carre[MAX]; // variable pour les carrés (on ne peut pas utiliser
                  // b, pour ne le modifier !)
                  // par contre on pourra utiliser res[]
                  // directement, car multPol permet que
                  // entré et sortie soient les mêmes,
                  // et si b et res sont les mêmes, en tout cas
                  // b est sauvegardé dans carre au debut
  unsigned int degcarre;
  unsigned int i;
  degcarre = degb; 
  for(i = 0; i <= degb; i++) carre[i] = b[i]; // copie de b sur carre
  *degres = 0;
  res[0] = 1; // initialisation à 1 du polynome
  // l'ordre est important, si on copie b sur carre après avoir
  // initialisé res, peut être que b soit effaçé
  while (e != 0) {
    if(e%2 != 0) {
      multPol(res, degres, res, *degres, carre, degcarre);
                    // res = res*carre
    }
    e /= 2;
    multPol(carre, &degcarre, carre, degcarre, carre, degcarre);
                    // carre = carre*carre
  }
}
